// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/crm/crm_models"
)

// GetAccountsObservableReader is a Reader for the GetAccountsObservable structure.
type GetAccountsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAccountsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAccountsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetAccountsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetAccountsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetAccountsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetAccountsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetAccountsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetAccountsObservableOK creates a GetAccountsObservableOK with default headers values
func NewGetAccountsObservableOK() *GetAccountsObservableOK {
	return &GetAccountsObservableOK{}
}

/*GetAccountsObservableOK handles this case with default header values.

Taxnexus Response with an array of Account objects
*/
type GetAccountsObservableOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload []*crm_models.Account
}

func (o *GetAccountsObservableOK) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableOK  %+v", 200, o.Payload)
}

func (o *GetAccountsObservableOK) GetPayload() []*crm_models.Account {
	return o.Payload
}

func (o *GetAccountsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableUnauthorized creates a GetAccountsObservableUnauthorized with default headers values
func NewGetAccountsObservableUnauthorized() *GetAccountsObservableUnauthorized {
	return &GetAccountsObservableUnauthorized{}
}

/*GetAccountsObservableUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetAccountsObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetAccountsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAccountsObservableUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableForbidden creates a GetAccountsObservableForbidden with default headers values
func NewGetAccountsObservableForbidden() *GetAccountsObservableForbidden {
	return &GetAccountsObservableForbidden{}
}

/*GetAccountsObservableForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetAccountsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetAccountsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetAccountsObservableForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableNotFound creates a GetAccountsObservableNotFound with default headers values
func NewGetAccountsObservableNotFound() *GetAccountsObservableNotFound {
	return &GetAccountsObservableNotFound{}
}

/*GetAccountsObservableNotFound handles this case with default header values.

Resource was not found
*/
type GetAccountsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetAccountsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetAccountsObservableNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableUnprocessableEntity creates a GetAccountsObservableUnprocessableEntity with default headers values
func NewGetAccountsObservableUnprocessableEntity() *GetAccountsObservableUnprocessableEntity {
	return &GetAccountsObservableUnprocessableEntity{}
}

/*GetAccountsObservableUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetAccountsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetAccountsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetAccountsObservableUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableInternalServerError creates a GetAccountsObservableInternalServerError with default headers values
func NewGetAccountsObservableInternalServerError() *GetAccountsObservableInternalServerError {
	return &GetAccountsObservableInternalServerError{}
}

/*GetAccountsObservableInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetAccountsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetAccountsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAccountsObservableInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
