// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/crm/crm_models"
)

// DeleteContactReader is a Reader for the DeleteContact structure.
type DeleteContactReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteContactReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteContactOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteContactUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteContactForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteContactNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteContactUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteContactInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteContactOK creates a DeleteContactOK with default headers values
func NewDeleteContactOK() *DeleteContactOK {
	return &DeleteContactOK{}
}

/*DeleteContactOK handles this case with default header values.

Taxnexus Response with Message Objects with Delete Status
*/
type DeleteContactOK struct {
	AccessControlAllowOrigin string

	Payload *crm_models.DeleteResponse
}

func (o *DeleteContactOK) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactOK  %+v", 200, o.Payload)
}

func (o *DeleteContactOK) GetPayload() *crm_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteContactOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactUnauthorized creates a DeleteContactUnauthorized with default headers values
func NewDeleteContactUnauthorized() *DeleteContactUnauthorized {
	return &DeleteContactUnauthorized{}
}

/*DeleteContactUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteContactUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *DeleteContactUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteContactUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactForbidden creates a DeleteContactForbidden with default headers values
func NewDeleteContactForbidden() *DeleteContactForbidden {
	return &DeleteContactForbidden{}
}

/*DeleteContactForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteContactForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *DeleteContactForbidden) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactForbidden  %+v", 403, o.Payload)
}

func (o *DeleteContactForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactNotFound creates a DeleteContactNotFound with default headers values
func NewDeleteContactNotFound() *DeleteContactNotFound {
	return &DeleteContactNotFound{}
}

/*DeleteContactNotFound handles this case with default header values.

Resource was not found
*/
type DeleteContactNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *DeleteContactNotFound) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactNotFound  %+v", 404, o.Payload)
}

func (o *DeleteContactNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactUnprocessableEntity creates a DeleteContactUnprocessableEntity with default headers values
func NewDeleteContactUnprocessableEntity() *DeleteContactUnprocessableEntity {
	return &DeleteContactUnprocessableEntity{}
}

/*DeleteContactUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteContactUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *DeleteContactUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteContactUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactInternalServerError creates a DeleteContactInternalServerError with default headers values
func NewDeleteContactInternalServerError() *DeleteContactInternalServerError {
	return &DeleteContactInternalServerError{}
}

/*DeleteContactInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteContactInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *DeleteContactInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteContactInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
