// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetDatabasesObservableReader is a Reader for the GetDatabasesObservable structure.
type GetDatabasesObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatabasesObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatabasesObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetDatabasesObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetDatabasesObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetDatabasesObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetDatabasesObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetDatabasesObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetDatabasesObservableOK creates a GetDatabasesObservableOK with default headers values
func NewGetDatabasesObservableOK() *GetDatabasesObservableOK {
	return &GetDatabasesObservableOK{}
}

/*GetDatabasesObservableOK handles this case with default header values.

Single Database record response
*/
type GetDatabasesObservableOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload []*devops_models.Database
}

func (o *GetDatabasesObservableOK) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableOK  %+v", 200, o.Payload)
}

func (o *GetDatabasesObservableOK) GetPayload() []*devops_models.Database {
	return o.Payload
}

func (o *GetDatabasesObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableUnauthorized creates a GetDatabasesObservableUnauthorized with default headers values
func NewGetDatabasesObservableUnauthorized() *GetDatabasesObservableUnauthorized {
	return &GetDatabasesObservableUnauthorized{}
}

/*GetDatabasesObservableUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetDatabasesObservableUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetDatabasesObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabasesObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableForbidden creates a GetDatabasesObservableForbidden with default headers values
func NewGetDatabasesObservableForbidden() *GetDatabasesObservableForbidden {
	return &GetDatabasesObservableForbidden{}
}

/*GetDatabasesObservableForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetDatabasesObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetDatabasesObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabasesObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableNotFound creates a GetDatabasesObservableNotFound with default headers values
func NewGetDatabasesObservableNotFound() *GetDatabasesObservableNotFound {
	return &GetDatabasesObservableNotFound{}
}

/*GetDatabasesObservableNotFound handles this case with default header values.

Resource was not found
*/
type GetDatabasesObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetDatabasesObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabasesObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableUnprocessableEntity creates a GetDatabasesObservableUnprocessableEntity with default headers values
func NewGetDatabasesObservableUnprocessableEntity() *GetDatabasesObservableUnprocessableEntity {
	return &GetDatabasesObservableUnprocessableEntity{}
}

/*GetDatabasesObservableUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetDatabasesObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetDatabasesObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabasesObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableInternalServerError creates a GetDatabasesObservableInternalServerError with default headers values
func NewGetDatabasesObservableInternalServerError() *GetDatabasesObservableInternalServerError {
	return &GetDatabasesObservableInternalServerError{}
}

/*GetDatabasesObservableInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetDatabasesObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetDatabasesObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabasesObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
