// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package devops_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/cluster"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/cors"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/database"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/ingest"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/job"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/service"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/template"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/tenant"
	"code.tnxs.net/taxnexus/lib/api/devops/devops_client/user"
)

// Default devops HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "devops.fabric.tnxs.net:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new devops HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Devops {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new devops HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Devops {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new devops client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Devops {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Devops)
	cli.Transport = transport
	cli.Cluster = cluster.New(transport, formats)
	cli.Cors = cors.New(transport, formats)
	cli.Database = database.New(transport, formats)
	cli.Ingest = ingest.New(transport, formats)
	cli.Job = job.New(transport, formats)
	cli.Service = service.New(transport, formats)
	cli.Template = template.New(transport, formats)
	cli.Tenant = tenant.New(transport, formats)
	cli.User = user.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Devops is a client for devops
type Devops struct {
	Cluster cluster.ClientService

	Cors cors.ClientService

	Database database.ClientService

	Ingest ingest.ClientService

	Job job.ClientService

	Service service.ClientService

	Template template.ClientService

	Tenant tenant.ClientService

	User user.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Devops) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.Cluster.SetTransport(transport)
	c.Cors.SetTransport(transport)
	c.Database.SetTransport(transport)
	c.Ingest.SetTransport(transport)
	c.Job.SetTransport(transport)
	c.Service.SetTransport(transport)
	c.Template.SetTransport(transport)
	c.Tenant.SetTransport(transport)
	c.User.SetTransport(transport)
}
