// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package job

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetJobsReader is a Reader for the GetJobs structure.
type GetJobsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetJobsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetJobsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetJobsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetJobsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetJobsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetJobsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetJobsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetJobsOK creates a GetJobsOK with default headers values
func NewGetJobsOK() *GetJobsOK {
	return &GetJobsOK{}
}

/*GetJobsOK handles this case with default header values.

Taxnexus Response with Job objects
*/
type GetJobsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.JobResponse
}

func (o *GetJobsOK) Error() string {
	return fmt.Sprintf("[GET /jobs][%d] getJobsOK  %+v", 200, o.Payload)
}

func (o *GetJobsOK) GetPayload() *devops_models.JobResponse {
	return o.Payload
}

func (o *GetJobsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.JobResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsUnauthorized creates a GetJobsUnauthorized with default headers values
func NewGetJobsUnauthorized() *GetJobsUnauthorized {
	return &GetJobsUnauthorized{}
}

/*GetJobsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetJobsUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetJobsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /jobs][%d] getJobsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetJobsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsForbidden creates a GetJobsForbidden with default headers values
func NewGetJobsForbidden() *GetJobsForbidden {
	return &GetJobsForbidden{}
}

/*GetJobsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetJobsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobsForbidden) Error() string {
	return fmt.Sprintf("[GET /jobs][%d] getJobsForbidden  %+v", 403, o.Payload)
}

func (o *GetJobsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsNotFound creates a GetJobsNotFound with default headers values
func NewGetJobsNotFound() *GetJobsNotFound {
	return &GetJobsNotFound{}
}

/*GetJobsNotFound handles this case with default header values.

Resource was not found
*/
type GetJobsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobsNotFound) Error() string {
	return fmt.Sprintf("[GET /jobs][%d] getJobsNotFound  %+v", 404, o.Payload)
}

func (o *GetJobsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsUnprocessableEntity creates a GetJobsUnprocessableEntity with default headers values
func NewGetJobsUnprocessableEntity() *GetJobsUnprocessableEntity {
	return &GetJobsUnprocessableEntity{}
}

/*GetJobsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetJobsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetJobsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /jobs][%d] getJobsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetJobsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobsInternalServerError creates a GetJobsInternalServerError with default headers values
func NewGetJobsInternalServerError() *GetJobsInternalServerError {
	return &GetJobsInternalServerError{}
}

/*GetJobsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetJobsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /jobs][%d] getJobsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetJobsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
