// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetServicesObservableReader is a Reader for the GetServicesObservable structure.
type GetServicesObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetServicesObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetServicesObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetServicesObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetServicesObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetServicesObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetServicesObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetServicesObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetServicesObservableOK creates a GetServicesObservableOK with default headers values
func NewGetServicesObservableOK() *GetServicesObservableOK {
	return &GetServicesObservableOK{}
}

/*GetServicesObservableOK handles this case with default header values.

Simple Service record response
*/
type GetServicesObservableOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload []*devops_models.Service
}

func (o *GetServicesObservableOK) Error() string {
	return fmt.Sprintf("[GET /services/observable][%d] getServicesObservableOK  %+v", 200, o.Payload)
}

func (o *GetServicesObservableOK) GetPayload() []*devops_models.Service {
	return o.Payload
}

func (o *GetServicesObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesObservableUnauthorized creates a GetServicesObservableUnauthorized with default headers values
func NewGetServicesObservableUnauthorized() *GetServicesObservableUnauthorized {
	return &GetServicesObservableUnauthorized{}
}

/*GetServicesObservableUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetServicesObservableUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetServicesObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /services/observable][%d] getServicesObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetServicesObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetServicesObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesObservableForbidden creates a GetServicesObservableForbidden with default headers values
func NewGetServicesObservableForbidden() *GetServicesObservableForbidden {
	return &GetServicesObservableForbidden{}
}

/*GetServicesObservableForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetServicesObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetServicesObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /services/observable][%d] getServicesObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetServicesObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetServicesObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesObservableNotFound creates a GetServicesObservableNotFound with default headers values
func NewGetServicesObservableNotFound() *GetServicesObservableNotFound {
	return &GetServicesObservableNotFound{}
}

/*GetServicesObservableNotFound handles this case with default header values.

Resource was not found
*/
type GetServicesObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetServicesObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /services/observable][%d] getServicesObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetServicesObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetServicesObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesObservableUnprocessableEntity creates a GetServicesObservableUnprocessableEntity with default headers values
func NewGetServicesObservableUnprocessableEntity() *GetServicesObservableUnprocessableEntity {
	return &GetServicesObservableUnprocessableEntity{}
}

/*GetServicesObservableUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetServicesObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetServicesObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /services/observable][%d] getServicesObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetServicesObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetServicesObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesObservableInternalServerError creates a GetServicesObservableInternalServerError with default headers values
func NewGetServicesObservableInternalServerError() *GetServicesObservableInternalServerError {
	return &GetServicesObservableInternalServerError{}
}

/*GetServicesObservableInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetServicesObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetServicesObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /services/observable][%d] getServicesObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetServicesObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetServicesObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
