// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package place

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new place API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for place API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetPlaceObservable(params *GetPlaceObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetPlaceObservableOK, error)

	GetPlaces(params *GetPlacesParams, authInfo runtime.ClientAuthInfoWriter) (*GetPlacesOK, error)

	PostPlaces(params *PostPlacesParams, authInfo runtime.ClientAuthInfoWriter) (*PostPlacesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetPlaceObservable gets places in an observable array

  Returns a place retrieval in a observable array
*/
func (a *Client) GetPlaceObservable(params *GetPlaceObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetPlaceObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPlaceObservableParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPlaceObservable",
		Method:             "GET",
		PathPattern:        "/places/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPlaceObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPlaceObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPlaceObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetPlaces retrieves places

  Retrieve Places, filter with parameters
*/
func (a *Client) GetPlaces(params *GetPlacesParams, authInfo runtime.ClientAuthInfoWriter) (*GetPlacesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPlacesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPlaces",
		Method:             "GET",
		PathPattern:        "/places",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPlacesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPlacesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPlaces: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPlaces stores new place records

  Store a batch of new Place records
*/
func (a *Client) PostPlaces(params *PostPlacesParams, authInfo runtime.ClientAuthInfoWriter) (*PostPlacesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPlacesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postPlaces",
		Method:             "POST",
		PathPattern:        "/places",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPlacesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPlacesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPlaces: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
