// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package journal_entry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new journal entry API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for journal entry API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetJournalEntries(params *GetJournalEntriesParams, authInfo runtime.ClientAuthInfoWriter) (*GetJournalEntriesOK, error)

	PostJournalEntries(params *PostJournalEntriesParams, authInfo runtime.ClientAuthInfoWriter) (*PostJournalEntriesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetJournalEntries gets a list of journal entries

  Return a list of Journal Entries by by Journal Entry ID
*/
func (a *Client) GetJournalEntries(params *GetJournalEntriesParams, authInfo runtime.ClientAuthInfoWriter) (*GetJournalEntriesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetJournalEntriesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getJournalEntries",
		Method:             "GET",
		PathPattern:        "/journalentries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetJournalEntriesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetJournalEntriesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getJournalEntries: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostJournalEntries creates new journal entry records

  Create new Journal Entry Records
*/
func (a *Client) PostJournalEntries(params *PostJournalEntriesParams, authInfo runtime.ClientAuthInfoWriter) (*PostJournalEntriesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostJournalEntriesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postJournalEntries",
		Method:             "POST",
		PathPattern:        "/journalentries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostJournalEntriesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostJournalEntriesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postJournalEntries: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
