// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package period

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new period API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for period API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetPeriods(params *GetPeriodsParams, authInfo runtime.ClientAuthInfoWriter) (*GetPeriodsOK, error)

	PostPeriods(params *PostPeriodsParams, authInfo runtime.ClientAuthInfoWriter) (*PostPeriodsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetPeriods gets a list of periods

  Return a list of Periods for an Account
*/
func (a *Client) GetPeriods(params *GetPeriodsParams, authInfo runtime.ClientAuthInfoWriter) (*GetPeriodsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPeriodsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPeriods",
		Method:             "GET",
		PathPattern:        "/periods",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPeriodsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPeriodsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPeriods: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPeriods creates new periods

  Update Period records
*/
func (a *Client) PostPeriods(params *PostPeriodsParams, authInfo runtime.ClientAuthInfoWriter) (*PostPeriodsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPeriodsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postPeriods",
		Method:             "POST",
		PathPattern:        "/periods",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPeriodsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPeriodsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPeriods: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
