// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package packages

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// GetPackagesReader is a Reader for the GetPackages structure.
type GetPackagesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPackagesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPackagesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetPackagesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetPackagesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetPackagesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetPackagesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetPackagesOK creates a GetPackagesOK with default headers values
func NewGetPackagesOK() *GetPackagesOK {
	return &GetPackagesOK{}
}

/*GetPackagesOK handles this case with default header values.

A list of Packages was retrieved
*/
type GetPackagesOK struct {
	Payload *metrc_gw_models.PackageResponse
}

func (o *GetPackagesOK) Error() string {
	return fmt.Sprintf("[GET /packages][%d] getPackagesOK  %+v", 200, o.Payload)
}

func (o *GetPackagesOK) GetPayload() *metrc_gw_models.PackageResponse {
	return o.Payload
}

func (o *GetPackagesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.PackageResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPackagesUnauthorized creates a GetPackagesUnauthorized with default headers values
func NewGetPackagesUnauthorized() *GetPackagesUnauthorized {
	return &GetPackagesUnauthorized{}
}

/*GetPackagesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetPackagesUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPackagesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /packages][%d] getPackagesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetPackagesUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPackagesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPackagesForbidden creates a GetPackagesForbidden with default headers values
func NewGetPackagesForbidden() *GetPackagesForbidden {
	return &GetPackagesForbidden{}
}

/*GetPackagesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetPackagesForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPackagesForbidden) Error() string {
	return fmt.Sprintf("[GET /packages][%d] getPackagesForbidden  %+v", 403, o.Payload)
}

func (o *GetPackagesForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPackagesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPackagesNotFound creates a GetPackagesNotFound with default headers values
func NewGetPackagesNotFound() *GetPackagesNotFound {
	return &GetPackagesNotFound{}
}

/*GetPackagesNotFound handles this case with default header values.

Resource was not found
*/
type GetPackagesNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPackagesNotFound) Error() string {
	return fmt.Sprintf("[GET /packages][%d] getPackagesNotFound  %+v", 404, o.Payload)
}

func (o *GetPackagesNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPackagesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPackagesInternalServerError creates a GetPackagesInternalServerError with default headers values
func NewGetPackagesInternalServerError() *GetPackagesInternalServerError {
	return &GetPackagesInternalServerError{}
}

/*GetPackagesInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetPackagesInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPackagesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /packages][%d] getPackagesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetPackagesInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPackagesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
