// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package plants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// GetPlantsReader is a Reader for the GetPlants structure.
type GetPlantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPlantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPlantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetPlantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetPlantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetPlantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetPlantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetPlantsOK creates a GetPlantsOK with default headers values
func NewGetPlantsOK() *GetPlantsOK {
	return &GetPlantsOK{}
}

/*GetPlantsOK handles this case with default header values.

Plants were successfully retrieved
*/
type GetPlantsOK struct {
	Payload *metrc_gw_models.PlantResponse
}

func (o *GetPlantsOK) Error() string {
	return fmt.Sprintf("[GET /plants][%d] getPlantsOK  %+v", 200, o.Payload)
}

func (o *GetPlantsOK) GetPayload() *metrc_gw_models.PlantResponse {
	return o.Payload
}

func (o *GetPlantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.PlantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPlantsUnauthorized creates a GetPlantsUnauthorized with default headers values
func NewGetPlantsUnauthorized() *GetPlantsUnauthorized {
	return &GetPlantsUnauthorized{}
}

/*GetPlantsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetPlantsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPlantsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /plants][%d] getPlantsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetPlantsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPlantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPlantsForbidden creates a GetPlantsForbidden with default headers values
func NewGetPlantsForbidden() *GetPlantsForbidden {
	return &GetPlantsForbidden{}
}

/*GetPlantsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetPlantsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPlantsForbidden) Error() string {
	return fmt.Sprintf("[GET /plants][%d] getPlantsForbidden  %+v", 403, o.Payload)
}

func (o *GetPlantsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPlantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPlantsNotFound creates a GetPlantsNotFound with default headers values
func NewGetPlantsNotFound() *GetPlantsNotFound {
	return &GetPlantsNotFound{}
}

/*GetPlantsNotFound handles this case with default header values.

Resource was not found
*/
type GetPlantsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPlantsNotFound) Error() string {
	return fmt.Sprintf("[GET /plants][%d] getPlantsNotFound  %+v", 404, o.Payload)
}

func (o *GetPlantsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPlantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPlantsInternalServerError creates a GetPlantsInternalServerError with default headers values
func NewGetPlantsInternalServerError() *GetPlantsInternalServerError {
	return &GetPlantsInternalServerError{}
}

/*GetPlantsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetPlantsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *GetPlantsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /plants][%d] getPlantsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetPlantsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetPlantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
