// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package plants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PostPlantsReader is a Reader for the PostPlants structure.
type PostPlantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostPlantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostPlantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostPlantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostPlantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostPlantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostPlantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostPlantsOK creates a PostPlantsOK with default headers values
func NewPostPlantsOK() *PostPlantsOK {
	return &PostPlantsOK{}
}

/*PostPlantsOK handles this case with default header values.

An array of Plants records with the new IDs
*/
type PostPlantsOK struct {
	Payload *metrc_gw_models.PlantResponse
}

func (o *PostPlantsOK) Error() string {
	return fmt.Sprintf("[POST /plants][%d] postPlantsOK  %+v", 200, o.Payload)
}

func (o *PostPlantsOK) GetPayload() *metrc_gw_models.PlantResponse {
	return o.Payload
}

func (o *PostPlantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.PlantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPlantsUnauthorized creates a PostPlantsUnauthorized with default headers values
func NewPostPlantsUnauthorized() *PostPlantsUnauthorized {
	return &PostPlantsUnauthorized{}
}

/*PostPlantsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostPlantsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPlantsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /plants][%d] postPlantsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostPlantsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPlantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPlantsForbidden creates a PostPlantsForbidden with default headers values
func NewPostPlantsForbidden() *PostPlantsForbidden {
	return &PostPlantsForbidden{}
}

/*PostPlantsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostPlantsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPlantsForbidden) Error() string {
	return fmt.Sprintf("[POST /plants][%d] postPlantsForbidden  %+v", 403, o.Payload)
}

func (o *PostPlantsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPlantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPlantsNotFound creates a PostPlantsNotFound with default headers values
func NewPostPlantsNotFound() *PostPlantsNotFound {
	return &PostPlantsNotFound{}
}

/*PostPlantsNotFound handles this case with default header values.

Resource was not found
*/
type PostPlantsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPlantsNotFound) Error() string {
	return fmt.Sprintf("[POST /plants][%d] postPlantsNotFound  %+v", 404, o.Payload)
}

func (o *PostPlantsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPlantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPlantsInternalServerError creates a PostPlantsInternalServerError with default headers values
func NewPostPlantsInternalServerError() *PostPlantsInternalServerError {
	return &PostPlantsInternalServerError{}
}

/*PostPlantsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostPlantsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPlantsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /plants][%d] postPlantsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostPlantsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPlantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
