// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package rooms

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// GetRoomsReader is a Reader for the GetRooms structure.
type GetRoomsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRoomsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRoomsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetRoomsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetRoomsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetRoomsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRoomsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetRoomsOK creates a GetRoomsOK with default headers values
func NewGetRoomsOK() *GetRoomsOK {
	return &GetRoomsOK{}
}

/*GetRoomsOK handles this case with default header values.

Rooms were successfully retrieved
*/
type GetRoomsOK struct {
	Payload *metrc_gw_models.RoomResponse
}

func (o *GetRoomsOK) Error() string {
	return fmt.Sprintf("[GET /rooms][%d] getRoomsOK  %+v", 200, o.Payload)
}

func (o *GetRoomsOK) GetPayload() *metrc_gw_models.RoomResponse {
	return o.Payload
}

func (o *GetRoomsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.RoomResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRoomsUnauthorized creates a GetRoomsUnauthorized with default headers values
func NewGetRoomsUnauthorized() *GetRoomsUnauthorized {
	return &GetRoomsUnauthorized{}
}

/*GetRoomsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetRoomsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *GetRoomsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /rooms][%d] getRoomsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetRoomsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetRoomsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRoomsForbidden creates a GetRoomsForbidden with default headers values
func NewGetRoomsForbidden() *GetRoomsForbidden {
	return &GetRoomsForbidden{}
}

/*GetRoomsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetRoomsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *GetRoomsForbidden) Error() string {
	return fmt.Sprintf("[GET /rooms][%d] getRoomsForbidden  %+v", 403, o.Payload)
}

func (o *GetRoomsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetRoomsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRoomsNotFound creates a GetRoomsNotFound with default headers values
func NewGetRoomsNotFound() *GetRoomsNotFound {
	return &GetRoomsNotFound{}
}

/*GetRoomsNotFound handles this case with default header values.

Resource was not found
*/
type GetRoomsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *GetRoomsNotFound) Error() string {
	return fmt.Sprintf("[GET /rooms][%d] getRoomsNotFound  %+v", 404, o.Payload)
}

func (o *GetRoomsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetRoomsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRoomsInternalServerError creates a GetRoomsInternalServerError with default headers values
func NewGetRoomsInternalServerError() *GetRoomsInternalServerError {
	return &GetRoomsInternalServerError{}
}

/*GetRoomsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetRoomsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *GetRoomsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /rooms][%d] getRoomsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetRoomsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetRoomsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
