// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package sales

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// DeleteSalesReceiptsReader is a Reader for the DeleteSalesReceipts structure.
type DeleteSalesReceiptsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteSalesReceiptsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteSalesReceiptsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteSalesReceiptsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteSalesReceiptsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteSalesReceiptsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteSalesReceiptsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteSalesReceiptsOK creates a DeleteSalesReceiptsOK with default headers values
func NewDeleteSalesReceiptsOK() *DeleteSalesReceiptsOK {
	return &DeleteSalesReceiptsOK{}
}

/*DeleteSalesReceiptsOK handles this case with default header values.

Sales Receipt was successfully deleted
*/
type DeleteSalesReceiptsOK struct {
	Payload *metrc_gw_models.SalesReceiptResponse
}

func (o *DeleteSalesReceiptsOK) Error() string {
	return fmt.Sprintf("[DELETE /sales/receipts][%d] deleteSalesReceiptsOK  %+v", 200, o.Payload)
}

func (o *DeleteSalesReceiptsOK) GetPayload() *metrc_gw_models.SalesReceiptResponse {
	return o.Payload
}

func (o *DeleteSalesReceiptsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.SalesReceiptResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSalesReceiptsUnauthorized creates a DeleteSalesReceiptsUnauthorized with default headers values
func NewDeleteSalesReceiptsUnauthorized() *DeleteSalesReceiptsUnauthorized {
	return &DeleteSalesReceiptsUnauthorized{}
}

/*DeleteSalesReceiptsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteSalesReceiptsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteSalesReceiptsUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /sales/receipts][%d] deleteSalesReceiptsUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteSalesReceiptsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteSalesReceiptsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSalesReceiptsForbidden creates a DeleteSalesReceiptsForbidden with default headers values
func NewDeleteSalesReceiptsForbidden() *DeleteSalesReceiptsForbidden {
	return &DeleteSalesReceiptsForbidden{}
}

/*DeleteSalesReceiptsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteSalesReceiptsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteSalesReceiptsForbidden) Error() string {
	return fmt.Sprintf("[DELETE /sales/receipts][%d] deleteSalesReceiptsForbidden  %+v", 403, o.Payload)
}

func (o *DeleteSalesReceiptsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteSalesReceiptsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSalesReceiptsNotFound creates a DeleteSalesReceiptsNotFound with default headers values
func NewDeleteSalesReceiptsNotFound() *DeleteSalesReceiptsNotFound {
	return &DeleteSalesReceiptsNotFound{}
}

/*DeleteSalesReceiptsNotFound handles this case with default header values.

Resource was not found
*/
type DeleteSalesReceiptsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteSalesReceiptsNotFound) Error() string {
	return fmt.Sprintf("[DELETE /sales/receipts][%d] deleteSalesReceiptsNotFound  %+v", 404, o.Payload)
}

func (o *DeleteSalesReceiptsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteSalesReceiptsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSalesReceiptsInternalServerError creates a DeleteSalesReceiptsInternalServerError with default headers values
func NewDeleteSalesReceiptsInternalServerError() *DeleteSalesReceiptsInternalServerError {
	return &DeleteSalesReceiptsInternalServerError{}
}

/*DeleteSalesReceiptsInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteSalesReceiptsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteSalesReceiptsInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /sales/receipts][%d] deleteSalesReceiptsInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteSalesReceiptsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteSalesReceiptsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
