// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package quote

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PutQuotesReader is a Reader for the PutQuotes structure.
type PutQuotesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutQuotesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutQuotesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutQuotesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutQuotesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutQuotesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutQuotesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutQuotesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutQuotesOK creates a PutQuotesOK with default headers values
func NewPutQuotesOK() *PutQuotesOK {
	return &PutQuotesOK{}
}

/*PutQuotesOK handles this case with default header values.

Taxnexus Response with an array of Quote objects
*/
type PutQuotesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.QuoteResponse
}

func (o *PutQuotesOK) Error() string {
	return fmt.Sprintf("[PUT /quotes][%d] putQuotesOK  %+v", 200, o.Payload)
}

func (o *PutQuotesOK) GetPayload() *ops_models.QuoteResponse {
	return o.Payload
}

func (o *PutQuotesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.QuoteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutQuotesUnauthorized creates a PutQuotesUnauthorized with default headers values
func NewPutQuotesUnauthorized() *PutQuotesUnauthorized {
	return &PutQuotesUnauthorized{}
}

/*PutQuotesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutQuotesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutQuotesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /quotes][%d] putQuotesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutQuotesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutQuotesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutQuotesForbidden creates a PutQuotesForbidden with default headers values
func NewPutQuotesForbidden() *PutQuotesForbidden {
	return &PutQuotesForbidden{}
}

/*PutQuotesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutQuotesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutQuotesForbidden) Error() string {
	return fmt.Sprintf("[PUT /quotes][%d] putQuotesForbidden  %+v", 403, o.Payload)
}

func (o *PutQuotesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutQuotesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutQuotesNotFound creates a PutQuotesNotFound with default headers values
func NewPutQuotesNotFound() *PutQuotesNotFound {
	return &PutQuotesNotFound{}
}

/*PutQuotesNotFound handles this case with default header values.

Resource was not found
*/
type PutQuotesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutQuotesNotFound) Error() string {
	return fmt.Sprintf("[PUT /quotes][%d] putQuotesNotFound  %+v", 404, o.Payload)
}

func (o *PutQuotesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutQuotesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutQuotesUnprocessableEntity creates a PutQuotesUnprocessableEntity with default headers values
func NewPutQuotesUnprocessableEntity() *PutQuotesUnprocessableEntity {
	return &PutQuotesUnprocessableEntity{}
}

/*PutQuotesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutQuotesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutQuotesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /quotes][%d] putQuotesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutQuotesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutQuotesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutQuotesInternalServerError creates a PutQuotesInternalServerError with default headers values
func NewPutQuotesInternalServerError() *PutQuotesInternalServerError {
	return &PutQuotesInternalServerError{}
}

/*PutQuotesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutQuotesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutQuotesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /quotes][%d] putQuotesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutQuotesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutQuotesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
