// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package quote

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new quote API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for quote API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteQuote(params *DeleteQuoteParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteQuoteOK, error)

	GetQuotes(params *GetQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*GetQuotesOK, error)

	PostQuotes(params *PostQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*PostQuotesOK, error)

	PutQuotes(params *PutQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*PutQuotesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteQuote deletes a quote

  Delete quote by ID
*/
func (a *Client) DeleteQuote(params *DeleteQuoteParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteQuoteOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteQuoteParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteQuote",
		Method:             "DELETE",
		PathPattern:        "/quotes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteQuoteReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteQuoteOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteQuote: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetQuotes gets a list of invoices

  Return a list of available quotes
*/
func (a *Client) GetQuotes(params *GetQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*GetQuotesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetQuotesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getQuotes",
		Method:             "GET",
		PathPattern:        "/quotes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetQuotesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetQuotesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getQuotes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostQuotes creates a new quotes

  Create New Quotes
*/
func (a *Client) PostQuotes(params *PostQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*PostQuotesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostQuotesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postQuotes",
		Method:             "POST",
		PathPattern:        "/quotes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostQuotesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostQuotesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postQuotes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutQuotes puts a list of quotes

  Put a list of Quotes
*/
func (a *Client) PutQuotes(params *PutQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*PutQuotesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutQuotesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putQuotes",
		Method:             "PUT",
		PathPattern:        "/quotes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutQuotesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutQuotesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putQuotes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
