// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package filing

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetFilingsParams creates a new GetFilingsParams object
// with the default values initialized.
func NewGetFilingsParams() *GetFilingsParams {
	var ()
	return &GetFilingsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetFilingsParamsWithTimeout creates a new GetFilingsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetFilingsParamsWithTimeout(timeout time.Duration) *GetFilingsParams {
	var ()
	return &GetFilingsParams{

		timeout: timeout,
	}
}

// NewGetFilingsParamsWithContext creates a new GetFilingsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetFilingsParamsWithContext(ctx context.Context) *GetFilingsParams {
	var ()
	return &GetFilingsParams{

		Context: ctx,
	}
}

// NewGetFilingsParamsWithHTTPClient creates a new GetFilingsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetFilingsParamsWithHTTPClient(client *http.Client) *GetFilingsParams {
	var ()
	return &GetFilingsParams{
		HTTPClient: client,
	}
}

/*GetFilingsParams contains all the parameters to send to the API endpoint
for the get filings operation typically these are written to a http.Request
*/
type GetFilingsParams struct {

	/*CompanyID
	  Taxnexus Record Id of a Company

	*/
	CompanyID *string
	/*FilingID
	  Taxnexus Record Id of a Filing

	*/
	FilingID *string
	/*ID
	  Taxnexus Id of the record to be retrieved

	*/
	ID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get filings params
func (o *GetFilingsParams) WithTimeout(timeout time.Duration) *GetFilingsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get filings params
func (o *GetFilingsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get filings params
func (o *GetFilingsParams) WithContext(ctx context.Context) *GetFilingsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get filings params
func (o *GetFilingsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get filings params
func (o *GetFilingsParams) WithHTTPClient(client *http.Client) *GetFilingsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get filings params
func (o *GetFilingsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCompanyID adds the companyID to the get filings params
func (o *GetFilingsParams) WithCompanyID(companyID *string) *GetFilingsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get filings params
func (o *GetFilingsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithFilingID adds the filingID to the get filings params
func (o *GetFilingsParams) WithFilingID(filingID *string) *GetFilingsParams {
	o.SetFilingID(filingID)
	return o
}

// SetFilingID adds the filingId to the get filings params
func (o *GetFilingsParams) SetFilingID(filingID *string) {
	o.FilingID = filingID
}

// WithID adds the id to the get filings params
func (o *GetFilingsParams) WithID(id *string) *GetFilingsParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get filings params
func (o *GetFilingsParams) SetID(id *string) {
	o.ID = id
}

// WithLimit adds the limit to the get filings params
func (o *GetFilingsParams) WithLimit(limit *int64) *GetFilingsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get filings params
func (o *GetFilingsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get filings params
func (o *GetFilingsParams) WithOffset(offset *int64) *GetFilingsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get filings params
func (o *GetFilingsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetFilingsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.FilingID != nil {

		// query param filingId
		var qrFilingID string
		if o.FilingID != nil {
			qrFilingID = *o.FilingID
		}
		qFilingID := qrFilingID
		if qFilingID != "" {
			if err := r.SetQueryParam("filingId", qFilingID); err != nil {
				return err
			}
		}

	}

	if o.ID != nil {

		// query param id
		var qrID string
		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {
			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
