// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package filing

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// GetFilingsReader is a Reader for the GetFilings structure.
type GetFilingsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFilingsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetFilingsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetFilingsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetFilingsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetFilingsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetFilingsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetFilingsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFilingsOK creates a GetFilingsOK with default headers values
func NewGetFilingsOK() *GetFilingsOK {
	return &GetFilingsOK{}
}

/*GetFilingsOK handles this case with default header values.

Taxnexus Response with an array of Filing objects
*/
type GetFilingsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.FilingResponse
}

func (o *GetFilingsOK) Error() string {
	return fmt.Sprintf("[GET /filings][%d] getFilingsOK  %+v", 200, o.Payload)
}

func (o *GetFilingsOK) GetPayload() *regs_models.FilingResponse {
	return o.Payload
}

func (o *GetFilingsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.FilingResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFilingsUnauthorized creates a GetFilingsUnauthorized with default headers values
func NewGetFilingsUnauthorized() *GetFilingsUnauthorized {
	return &GetFilingsUnauthorized{}
}

/*GetFilingsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetFilingsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetFilingsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /filings][%d] getFilingsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetFilingsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetFilingsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFilingsForbidden creates a GetFilingsForbidden with default headers values
func NewGetFilingsForbidden() *GetFilingsForbidden {
	return &GetFilingsForbidden{}
}

/*GetFilingsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetFilingsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetFilingsForbidden) Error() string {
	return fmt.Sprintf("[GET /filings][%d] getFilingsForbidden  %+v", 403, o.Payload)
}

func (o *GetFilingsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetFilingsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFilingsNotFound creates a GetFilingsNotFound with default headers values
func NewGetFilingsNotFound() *GetFilingsNotFound {
	return &GetFilingsNotFound{}
}

/*GetFilingsNotFound handles this case with default header values.

Resource was not found
*/
type GetFilingsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetFilingsNotFound) Error() string {
	return fmt.Sprintf("[GET /filings][%d] getFilingsNotFound  %+v", 404, o.Payload)
}

func (o *GetFilingsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetFilingsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFilingsUnprocessableEntity creates a GetFilingsUnprocessableEntity with default headers values
func NewGetFilingsUnprocessableEntity() *GetFilingsUnprocessableEntity {
	return &GetFilingsUnprocessableEntity{}
}

/*GetFilingsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetFilingsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetFilingsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /filings][%d] getFilingsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetFilingsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetFilingsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFilingsInternalServerError creates a GetFilingsInternalServerError with default headers values
func NewGetFilingsInternalServerError() *GetFilingsInternalServerError {
	return &GetFilingsInternalServerError{}
}

/*GetFilingsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetFilingsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetFilingsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /filings][%d] getFilingsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFilingsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetFilingsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
