// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package filing_type

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new filing type API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for filing type API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetFilingTypes(params *GetFilingTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetFilingTypesOK, error)

	PostFilingTypes(params *PostFilingTypesParams, authInfo runtime.ClientAuthInfoWriter) (*PostFilingTypesOK, error)

	PutFilingTypes(params *PutFilingTypesParams, authInfo runtime.ClientAuthInfoWriter) (*PutFilingTypesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetFilingTypes gets a list of filing types

  Return a list of available Regulatory FilingTypes
*/
func (a *Client) GetFilingTypes(params *GetFilingTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetFilingTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetFilingTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getFilingTypes",
		Method:             "GET",
		PathPattern:        "/filingtypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetFilingTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetFilingTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getFilingTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostFilingTypes creates new filing types

  Create new FilingTypes
*/
func (a *Client) PostFilingTypes(params *PostFilingTypesParams, authInfo runtime.ClientAuthInfoWriter) (*PostFilingTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostFilingTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postFilingTypes",
		Method:             "POST",
		PathPattern:        "/filingtypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostFilingTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostFilingTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postFilingTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutFilingTypes updates a filing type

  Update all the fields in a FilingType record identified by Taxnexus ID
*/
func (a *Client) PutFilingTypes(params *PutFilingTypesParams, authInfo runtime.ClientAuthInfoWriter) (*PutFilingTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutFilingTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putFilingTypes",
		Method:             "PUT",
		PathPattern:        "/filingtypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutFilingTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutFilingTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putFilingTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
