// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package license

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PutLicensesReader is a Reader for the PutLicenses structure.
type PutLicensesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutLicensesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutLicensesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutLicensesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutLicensesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutLicensesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutLicensesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutLicensesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutLicensesOK creates a PutLicensesOK with default headers values
func NewPutLicensesOK() *PutLicensesOK {
	return &PutLicensesOK{}
}

/*PutLicensesOK handles this case with default header values.

Taxnexus Response with License objects
*/
type PutLicensesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.LicenseResponse
}

func (o *PutLicensesOK) Error() string {
	return fmt.Sprintf("[PUT /licenses][%d] putLicensesOK  %+v", 200, o.Payload)
}

func (o *PutLicensesOK) GetPayload() *regs_models.LicenseResponse {
	return o.Payload
}

func (o *PutLicensesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.LicenseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLicensesUnauthorized creates a PutLicensesUnauthorized with default headers values
func NewPutLicensesUnauthorized() *PutLicensesUnauthorized {
	return &PutLicensesUnauthorized{}
}

/*PutLicensesUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutLicensesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutLicensesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /licenses][%d] putLicensesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutLicensesUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutLicensesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLicensesForbidden creates a PutLicensesForbidden with default headers values
func NewPutLicensesForbidden() *PutLicensesForbidden {
	return &PutLicensesForbidden{}
}

/*PutLicensesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutLicensesForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutLicensesForbidden) Error() string {
	return fmt.Sprintf("[PUT /licenses][%d] putLicensesForbidden  %+v", 403, o.Payload)
}

func (o *PutLicensesForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutLicensesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLicensesNotFound creates a PutLicensesNotFound with default headers values
func NewPutLicensesNotFound() *PutLicensesNotFound {
	return &PutLicensesNotFound{}
}

/*PutLicensesNotFound handles this case with default header values.

Resource was not found
*/
type PutLicensesNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutLicensesNotFound) Error() string {
	return fmt.Sprintf("[PUT /licenses][%d] putLicensesNotFound  %+v", 404, o.Payload)
}

func (o *PutLicensesNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutLicensesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLicensesUnprocessableEntity creates a PutLicensesUnprocessableEntity with default headers values
func NewPutLicensesUnprocessableEntity() *PutLicensesUnprocessableEntity {
	return &PutLicensesUnprocessableEntity{}
}

/*PutLicensesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutLicensesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutLicensesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /licenses][%d] putLicensesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutLicensesUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutLicensesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLicensesInternalServerError creates a PutLicensesInternalServerError with default headers values
func NewPutLicensesInternalServerError() *PutLicensesInternalServerError {
	return &PutLicensesInternalServerError{}
}

/*PutLicensesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutLicensesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutLicensesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /licenses][%d] putLicensesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutLicensesInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutLicensesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
