// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package submission

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PostSubmissionsReader is a Reader for the PostSubmissions structure.
type PostSubmissionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostSubmissionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostSubmissionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostSubmissionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostSubmissionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostSubmissionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostSubmissionsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostSubmissionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostSubmissionsOK creates a PostSubmissionsOK with default headers values
func NewPostSubmissionsOK() *PostSubmissionsOK {
	return &PostSubmissionsOK{}
}

/*PostSubmissionsOK handles this case with default header values.

Taxnexus Response with Submission objects
*/
type PostSubmissionsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.SubmissionResponse
}

func (o *PostSubmissionsOK) Error() string {
	return fmt.Sprintf("[POST /submissions][%d] postSubmissionsOK  %+v", 200, o.Payload)
}

func (o *PostSubmissionsOK) GetPayload() *regs_models.SubmissionResponse {
	return o.Payload
}

func (o *PostSubmissionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.SubmissionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubmissionsUnauthorized creates a PostSubmissionsUnauthorized with default headers values
func NewPostSubmissionsUnauthorized() *PostSubmissionsUnauthorized {
	return &PostSubmissionsUnauthorized{}
}

/*PostSubmissionsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostSubmissionsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostSubmissionsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /submissions][%d] postSubmissionsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostSubmissionsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostSubmissionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubmissionsForbidden creates a PostSubmissionsForbidden with default headers values
func NewPostSubmissionsForbidden() *PostSubmissionsForbidden {
	return &PostSubmissionsForbidden{}
}

/*PostSubmissionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostSubmissionsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostSubmissionsForbidden) Error() string {
	return fmt.Sprintf("[POST /submissions][%d] postSubmissionsForbidden  %+v", 403, o.Payload)
}

func (o *PostSubmissionsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostSubmissionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubmissionsNotFound creates a PostSubmissionsNotFound with default headers values
func NewPostSubmissionsNotFound() *PostSubmissionsNotFound {
	return &PostSubmissionsNotFound{}
}

/*PostSubmissionsNotFound handles this case with default header values.

Resource was not found
*/
type PostSubmissionsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostSubmissionsNotFound) Error() string {
	return fmt.Sprintf("[POST /submissions][%d] postSubmissionsNotFound  %+v", 404, o.Payload)
}

func (o *PostSubmissionsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostSubmissionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubmissionsUnprocessableEntity creates a PostSubmissionsUnprocessableEntity with default headers values
func NewPostSubmissionsUnprocessableEntity() *PostSubmissionsUnprocessableEntity {
	return &PostSubmissionsUnprocessableEntity{}
}

/*PostSubmissionsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostSubmissionsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostSubmissionsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /submissions][%d] postSubmissionsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostSubmissionsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostSubmissionsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubmissionsInternalServerError creates a PostSubmissionsInternalServerError with default headers values
func NewPostSubmissionsInternalServerError() *PostSubmissionsInternalServerError {
	return &PostSubmissionsInternalServerError{}
}

/*PostSubmissionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostSubmissionsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostSubmissionsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /submissions][%d] postSubmissionsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostSubmissionsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostSubmissionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
