// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cash_receipts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new cash receipts API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for cash receipts API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetCashReceipts(params *GetCashReceiptsParams, authInfo runtime.ClientAuthInfoWriter) (*GetCashReceiptsOK, error)

	PostCashReceipts(params *PostCashReceiptsParams, authInfo runtime.ClientAuthInfoWriter) (*PostCashReceiptsOK, error)

	PutCashRecipts(params *PutCashReciptsParams, authInfo runtime.ClientAuthInfoWriter) (*PutCashReciptsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetCashReceipts gets a list of cash receipts

  Return a list of available Taxnexus Cash Receipts
*/
func (a *Client) GetCashReceipts(params *GetCashReceiptsParams, authInfo runtime.ClientAuthInfoWriter) (*GetCashReceiptsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetCashReceiptsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getCashReceipts",
		Method:             "GET",
		PathPattern:        "/cashreceipts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetCashReceiptsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetCashReceiptsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getCashReceipts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostCashReceipts creates new cash receipts

  Create New Cash Receipts
*/
func (a *Client) PostCashReceipts(params *PostCashReceiptsParams, authInfo runtime.ClientAuthInfoWriter) (*PostCashReceiptsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostCashReceiptsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postCashReceipts",
		Method:             "POST",
		PathPattern:        "/cashreceipts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostCashReceiptsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostCashReceiptsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postCashReceipts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutCashRecipts puts a list of cash receipts

  Put a list of Cash Receipts
*/
func (a *Client) PutCashRecipts(params *PutCashReciptsParams, authInfo runtime.ClientAuthInfoWriter) (*PutCashReciptsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutCashReciptsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putCashRecipts",
		Method:             "PUT",
		PathPattern:        "/cashreceipts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutCashReciptsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutCashReciptsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putCashRecipts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
