// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cash_receipts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetCashReceiptsParams creates a new GetCashReceiptsParams object
// with the default values initialized.
func NewGetCashReceiptsParams() *GetCashReceiptsParams {
	var ()
	return &GetCashReceiptsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCashReceiptsParamsWithTimeout creates a new GetCashReceiptsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCashReceiptsParamsWithTimeout(timeout time.Duration) *GetCashReceiptsParams {
	var ()
	return &GetCashReceiptsParams{

		timeout: timeout,
	}
}

// NewGetCashReceiptsParamsWithContext creates a new GetCashReceiptsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCashReceiptsParamsWithContext(ctx context.Context) *GetCashReceiptsParams {
	var ()
	return &GetCashReceiptsParams{

		Context: ctx,
	}
}

// NewGetCashReceiptsParamsWithHTTPClient creates a new GetCashReceiptsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetCashReceiptsParamsWithHTTPClient(client *http.Client) *GetCashReceiptsParams {
	var ()
	return &GetCashReceiptsParams{
		HTTPClient: client,
	}
}

/*GetCashReceiptsParams contains all the parameters to send to the API endpoint
for the get cash receipts operation typically these are written to a http.Request
*/
type GetCashReceiptsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CashReceiptID
	  Taxnexus Record Id of a Cash Receipt

	*/
	CashReceiptID *string
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get cash receipts params
func (o *GetCashReceiptsParams) WithTimeout(timeout time.Duration) *GetCashReceiptsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get cash receipts params
func (o *GetCashReceiptsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get cash receipts params
func (o *GetCashReceiptsParams) WithContext(ctx context.Context) *GetCashReceiptsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get cash receipts params
func (o *GetCashReceiptsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get cash receipts params
func (o *GetCashReceiptsParams) WithHTTPClient(client *http.Client) *GetCashReceiptsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get cash receipts params
func (o *GetCashReceiptsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get cash receipts params
func (o *GetCashReceiptsParams) WithAccountID(accountID *string) *GetCashReceiptsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get cash receipts params
func (o *GetCashReceiptsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get cash receipts params
func (o *GetCashReceiptsParams) WithActive(active *bool) *GetCashReceiptsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get cash receipts params
func (o *GetCashReceiptsParams) SetActive(active *bool) {
	o.Active = active
}

// WithCashReceiptID adds the cashReceiptID to the get cash receipts params
func (o *GetCashReceiptsParams) WithCashReceiptID(cashReceiptID *string) *GetCashReceiptsParams {
	o.SetCashReceiptID(cashReceiptID)
	return o
}

// SetCashReceiptID adds the cashReceiptId to the get cash receipts params
func (o *GetCashReceiptsParams) SetCashReceiptID(cashReceiptID *string) {
	o.CashReceiptID = cashReceiptID
}

// WithCompanyID adds the companyID to the get cash receipts params
func (o *GetCashReceiptsParams) WithCompanyID(companyID *string) *GetCashReceiptsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get cash receipts params
func (o *GetCashReceiptsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get cash receipts params
func (o *GetCashReceiptsParams) WithLimit(limit *int64) *GetCashReceiptsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get cash receipts params
func (o *GetCashReceiptsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get cash receipts params
func (o *GetCashReceiptsParams) WithOffset(offset *int64) *GetCashReceiptsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get cash receipts params
func (o *GetCashReceiptsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetCashReceiptsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CashReceiptID != nil {

		// query param cashReceiptId
		var qrCashReceiptID string
		if o.CashReceiptID != nil {
			qrCashReceiptID = *o.CashReceiptID
		}
		qCashReceiptID := qrCashReceiptID
		if qCashReceiptID != "" {
			if err := r.SetQueryParam("cashReceiptId", qCashReceiptID); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
