// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PutServicesReader is a Reader for the PutServices structure.
type PutServicesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutServicesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutServicesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutServicesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutServicesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutServicesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutServicesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutServicesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutServicesOK creates a PutServicesOK with default headers values
func NewPutServicesOK() *PutServicesOK {
	return &PutServicesOK{}
}

/*PutServicesOK handles this case with default header values.

Taxnexus Response with Service objects
*/
type PutServicesOK struct {
	Payload *sf_gate_models.ServiceResponse
}

func (o *PutServicesOK) Error() string {
	return fmt.Sprintf("[PUT /services][%d] putServicesOK  %+v", 200, o.Payload)
}

func (o *PutServicesOK) GetPayload() *sf_gate_models.ServiceResponse {
	return o.Payload
}

func (o *PutServicesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.ServiceResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutServicesUnauthorized creates a PutServicesUnauthorized with default headers values
func NewPutServicesUnauthorized() *PutServicesUnauthorized {
	return &PutServicesUnauthorized{}
}

/*PutServicesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutServicesUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PutServicesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /services][%d] putServicesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutServicesUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutServicesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutServicesForbidden creates a PutServicesForbidden with default headers values
func NewPutServicesForbidden() *PutServicesForbidden {
	return &PutServicesForbidden{}
}

/*PutServicesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutServicesForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PutServicesForbidden) Error() string {
	return fmt.Sprintf("[PUT /services][%d] putServicesForbidden  %+v", 403, o.Payload)
}

func (o *PutServicesForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutServicesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutServicesNotFound creates a PutServicesNotFound with default headers values
func NewPutServicesNotFound() *PutServicesNotFound {
	return &PutServicesNotFound{}
}

/*PutServicesNotFound handles this case with default header values.

Resource was not found
*/
type PutServicesNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PutServicesNotFound) Error() string {
	return fmt.Sprintf("[PUT /services][%d] putServicesNotFound  %+v", 404, o.Payload)
}

func (o *PutServicesNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutServicesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutServicesUnprocessableEntity creates a PutServicesUnprocessableEntity with default headers values
func NewPutServicesUnprocessableEntity() *PutServicesUnprocessableEntity {
	return &PutServicesUnprocessableEntity{}
}

/*PutServicesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutServicesUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *PutServicesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /services][%d] putServicesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutServicesUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutServicesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutServicesInternalServerError creates a PutServicesInternalServerError with default headers values
func NewPutServicesInternalServerError() *PutServicesInternalServerError {
	return &PutServicesInternalServerError{}
}

/*PutServicesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutServicesInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PutServicesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /services][%d] putServicesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutServicesInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutServicesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
