package types

import "database/sql"

// CashReceipt is a first class object type
type CashReceipt struct {
	ID                 string
	AccountID          string
	Amount             float64
	AppliedAmount      float64
	BillingContactID   string
	BillingRunID       string
	CashReceiptDate    sql.NullTime
	CashReceiptNumber  string
	CreatedByID        string
	CreatedDate        sql.NullTime
	Description        string
	Gateway            string
	GatewayKey         string
	GatewayMessage     string
	GatewayTransaction bool
	InvoiceID          string
	IsValid            bool
	LastModifiedByID   string
	LastModifiedDate   sql.NullTime
	PartnerAccountID   string
	PaymentMethodID    string
	PeriodID           string
	Posted             bool
	RecordType         string
	Ref                string
	Rejected           bool
	Source             string
	Status             string
	TemplateID         string
	TenantID           string
	Type               string
	UnappliedAmount    float64
	ValidPayment       bool
	XeroID             string
}
