package types

import "database/sql"

// Contact is a first-class object
type Contact struct {
	ID                 string
	AccountID          string
	AssistantName      string
	AssistantPhone     string
	BirthDate          sql.NullTime
	CreatedByID        string
	CreatedDate        sql.NullTime
	Department         string
	Description        string
	DoNotCall          bool
	Email              string
	EmailBounceDate    sql.NullTime
	EmailBouncedReason string
	EnrollmentStatus   string
	Fax                string
	FirstName          string
	HasOptedOutOfEmail bool
	HasOptedOutOfFax   bool
	HomePhone          string
	IsEmailBounced     bool
	IsProvisioned      bool
	LastModifiedByID   string
	LastModifiedDate   sql.NullTime
	LastName           string
	LeadSource         string
	Level              string
	LinkedIn           string
	MailingAddress     Address
	MailingLists       string
	MobilePhone        string
	Name               string
	OtherAddress       Address
	OtherPhone         string
	OwnerID            string
	PersonalEmail      string
	Phone              string
	PhotoURL           string
	RecruitingStatus   string
	Ref                string
	ReportsToID        string
	Salutation         string
	Status             string
	TenantID           string
	Title              string
	Type               string
}
