package types

import "database/sql"

// Filing is a first class object type
type Filing struct {
	ID                  string
	AccountName         string
	Amount              float64
	AuthorityID         string
	ContactID           string
	CreatedByID         string
	CreatedDate         sql.NullTime
	Date                sql.NullTime
	DueDate             sql.NullTime
	FilingNumber        string
	FilingTypeID        string
	Frequency           string
	Interest            float64
	InterestRate        float64
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	MonthNumber         int64
	OwnerID             string
	Penalty             float64
	PenaltyDays         float64
	PenaltyRate         float64
	PeriodID            string
	PreparerID          string
	QuarterNumber       int64
	Ref                 string
	ReportedAdjustments float64
	ReportedDeductions  float64
	ReportedNetRevenue  float64
	ReportedRate        float64
	ReportedRevenue     float64
	RevenueBase         float64
	RevenueNet          float64
	RevenueNotTaxable   float64
	SemiannualNumber    int64
	Status              string
	SubmissionID        string
	Subtotal            float64
	TaxOnTax            float64
	TaxTypeAccountID    string
	TenantID            string
	TotalAmount         float64
	UnitBase            float64
	YearNumber          int64
}
