package types

import "database/sql"

// Ingest is a first class object type
type Ingest struct {
	ID                     string
	AccountID              string
	Amount                 float64
	BackendID              string
	CompanyID              string
	CreatedByID            string
	CreatedDate            sql.NullTime
	Description            string
	EndDate                sql.NullTime
	Filename               string
	IngestDate             sql.NullTime
	IngestFailureReason    string
	IngestType             string
	InvoiceCount           int64
	JobID                  string
	LastModifiedByID       string
	LastModifiedDate       sql.NullTime
	MetrcLastModifiedEnd   sql.NullTime
	MetrcLastModifiedStart sql.NullTime
	MetrcLicense           string
	MetrcSalesReceiptID    int64
	MetrcState             string
	ObjectType             string
	ParentFK               string
	PeriodID               string
	PoCount                int64
	PostFailureReason      string
	RatingEngineID         string
	Ref                    string
	RevenueBase            float64
	RevenueNet             float64
	RevenueNotTaxable      float64
	StartDate              sql.NullTime
	Status                 string
	TaxOnTax               float64
	TaxTransactionCount    int64
	TenantID               string
	TemplateID             string
	UnitBase               int64
}
