package types

import "database/sql"

// State is a first class object type
type State struct {
	ID                  string
	TaxInstances        []*TaxInstance
	AccountID           string
	Amount              float64
	Code                string
	ContactID           string
	CountryID           string
	CreatedByID         string
	CreatedDate         sql.NullTime
	Division            string
	EnrollmentStatus    string
	FIPS                string
	Geocode             string
	GNIS                int64
	Interest            float64
	LandArea            int64
	Longitude           float64
	Latitude            float64
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	Name                string
	OwnerID             string
	Penalty             float64
	Ref                 string
	Region              string
	ReportedAdjustments float64
	ReportedDeductions  float64
	ReportedNetRevenue  float64
	ReportedRate        float64
	ReportedRevenue     float64
	RevenueBase         float64
	RevenueNet          float64
	RevenueNotTaxable   float64
	SGC                 string
	Status              string
	Subtotal            float64
	TemplateID          string
	TotalAmount         float64
	TotalArea           int64
	UnitBase            float64
	WaterArea           int64
}
