package types

import "database/sql"

// TaxType is a first class object type
type TaxType struct {
	ID                 string
	AccountID          string
	AccountingRuleCode string
	Active             bool
	AgencyType         string
	AgentID            string
	Amount             float64
	Category           string
	CollectorDomainID  string
	CompanyID          string
	ContactID          string
	CreatedByID        string
	CreatedDate        sql.NullTime
	Description        string
	EffectiveDate      sql.NullTime
	EndDate            sql.NullTime
	EnrollmentStatus   string
	FilingCity         string
	FilingCountry      string
	FilingEmail        string
	FilingMethod       string
	FilingPostalcode   string
	FilingState        string
	FilingStreet       string
	Fractional         bool
	Frequency          string
	GeocodeString      string
	InterestRate       float64
	IsMedicinal        bool
	IsRecreational     bool
	LastModifiedByID   string
	LastModifiedDate   sql.NullTime
	MarkupRate         float64
	Name               string
	OwnerID            string
	Passthrough        bool
	PenaltyDays        int64
	PenaltyRate        float64
	Rate               float64
	Reference          string
	RevenueBase        float64
	RevenueNet         float64
	RevenueNotTaxable  float64
	SalesRegulation    string
	Status             string
	TaxnexusCodeID     string
	TaxnexusNumber     string
	TemplateID         string
	UnitBase           float64
	Units              string
}
