package types

import "database/sql"

// TaxTypeAccount is a first class object type
type TaxTypeAccount struct {
	ID                  string
	AccountID           string
	AccountNumber       string
	Active              bool
	Amount              float64
	ContactID           string
	CreatedByID         string
	CreatedDate         sql.NullTime
	Description         string
	EndDate             sql.NullTime
	Interest            float64
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	Notes               string
	OwnerID             string
	ParentFK            string
	Penalty             float64
	Ref                 string
	ReportedAdjustments float64
	ReportedDeductions  float64
	ReportedNetRevenue  float64
	ReportedRate        float64
	ReportedRevenue     float64
	RevenueBase         float64
	RevenueNet          float64
	RevenueNotTaxable   float64
	StartDate           sql.NullTime
	Subtotal            float64
	Tax                 float64
	TaxOnTax            float64
	TaxTypeID           string
	TenantID            string
	TotalAmount         float64
	UnitBase            float64
}
